<?php
namespace Teknisa\PLA\Modules\Ciclo\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use TecFood\Services\User as UserService;

class pla10000CicloController extends \Teknisa\Libs\Controller\CRUD {
    
   protected $novoCodigo;
   protected $pla10000CicloService;
    
    
    public function __construct($crudService, $environment, $novoCodigo, $pla10000CicloService){
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->novoCodigo = $novoCodigo;
        $this-> pla10000CicloService = $pla10000CicloService;
    }
    
    public function save(DTO\Request $request, DTO\Response $response){
        
        $rows = $request->getDataSet()->getRows();
        if($rows[0]["ISNEW"] == true){
            foreach($rows as $row){
                $params = array(
                    ":CDCARDCICLO" => $row["CDCARDCICLO"],
                    ":CDPADCICLO" => $row["CDPADCICLO"],
                    ":NRSEQCNFCICLO" => $this->novoCodigo->getCodeByTableName('CNFCARDCICLO', $this->environment->getNrOrgTrab()),
                    ":CDTIPOPRAT" => $row["CDTIPOPRAT"],
                    ":DSCOMPTPCICLO" => $row["DSCOMPTPCICLO"],
                    ":IDOPCARDCICLO" => $row["IDOPCARDCICLO"],
                    ":NRORDCNFCICLO" => $row["NRORDCNFCICLO"]
                );    
                
                
                $this->pla10000CicloService->insert($params);
            }
        } else if($rows[0]["ISNEW"] == false){
            foreach($rows as $row){
                $params = array(
                    ":CDCARDCICLO" => $row["CDCARDCICLO"],
                    ":CDPADCICLO" => $row["CDPADCICLO"],
                    ":NRSEQCNFCICLO" => $row["NRSEQCNFCICLO"],
                    ":DSCOMPTPCICLO" => $row["DSCOMPTPCICLO"]
                );    
                
                
                $this->pla10000CicloService->update($params);
            }
        } 
    }
    
    public function getLastPosition(DTO\Request $request, DTO\Response $response){
        
        $row = $request->getDataSet()->getRows();
        $params = array(
            ":CDCARDCICLO" => $row[0]["CDCARDCICLO"],
            ":CDPADCICLO" => $row[0]["CDPADCICLO"]
        );    
        
        $response->addDataSet(new DataSet('RESULT', $this->pla10000CicloService->getLastPosition($params)));

    }
    
    public function getSequencial(DTO\Request $request, DTO\Response $response){
        
        $row = $request->getDataSet()->getRows();
        $params = array(
            ":CDCARDCICLO" => $row[0]["CDCARDCICLO"],
            ":CDPADCICLO" => $row[0]["CDPADCICLO"]
        );    
        
        $response->addDataSet(new DataSet('RESULT', $this->pla10000CicloService->getSequencial($params)));

    }
    
    public function updateID(DTO\Request $request, DTO\Response $response){
        
        $rows = $request->getDataSet()->getRows();
        
        foreach ($rows as $row) {
            $params = array(
                ":CDCARDCICLO" => $row["CDCARDCICLO"],
                ":CDPADCICLO" => $row["CDPADCICLO"],
                ":IDOPCARDCICLO" => $row["IDOPCARDCICLO"],
                ":NRSEQCNFCICLO" => $row["NRSEQCNFCICLO"]
            );    
            
            $this->pla10000CicloService->updateID($params);
        }

    }
    
    public function getSize(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $params = array(
            ":CDCARDCICLO" => $row[0]["CDCARDCICLO"],
            ":CDPADCICLO" => $row[0]["CDPADCICLO"]
        ); 
        
        $response->addDataSet(new DataSet('RESULT', $this->pla10000CicloService->getSize($params)));
    }
    
    public function getPosition(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $params = array(
            ":CDCARDCICLO" => $row[0]["CDCARDCICLO"],
            ":CDPADCICLO" => $row[0]["CDPADCICLO"],
            ":NRSEQCNFCICLO" => $row[0]["NRSEQCNFCICLO"]
        ); 
        
        $response->addDataSet(new DataSet('RESULT', $this->pla10000CicloService->getPosition($params)));
    }
    
    public function atualizarPosicao(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        foreach($rows as $row){
            $params = array(
                ":CDCARDCICLO" => $row["CDCARDCICLO"],
                ":CDPADCICLO" => $row["CDPADCICLO"],
                ":NRSEQCNFCICLO" => $row["NRSEQCNFCICLO"],
                ":NRORDCNFCICLO" => $row["NRORDCNFCICLO"]
            );    
            
            $this->pla10000CicloService->atualizarPosicao($params);
        }
    }
    
    public function deleteTipoPrato(DTO\Request $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $params = array(
            ":CDCARDCICLO" => $row[0]["CDCARDCICLO"],
            ":CDPADCICLO" => $row[0]["CDPADCICLO"],
            ":NRSEQCNFCICLO" => $row[0]["NRSEQCNFCICLO"],
            ":CDTIPOPRAT" => $row[0]["CDTIPOPRAT"]
        );    
            
        $this->pla10000CicloService->delete($params);
    }
    
}
